<?php

$CFG["dbHost"] = "localhost";
$CFG["dbName"] = "squidtl";
$CFG["dbUser"] = "squidtl";
$CFG["dbPwd"] = "";

if(file_exists("config.inc.php")) {
    $dbConfig = true;
    include "common.inc.php";
} else {
    $dbConfig = false;
}
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> 
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="it" lang="it">  
    <head>
	<title>SquidTL Installation</title>
	<meta http-equiv="content-type" content="text-html; charset=UTF-8"></meta>
	<link type='text/css' rel='stylesheet' href='style/common.css'></link>
	<link type='text/css' rel='stylesheet' href='style/datepicker.css'></link>
	<script src='js/jquery.js' type='text/javascript'></script>
	<script src='js/date.js' type='text/javascript'></script>
	<script src='js/jquery.timepicker.js' type='text/javascript'></script>
	<script src='js/jquery.datepicker.js' type='text/javascript'></script>
	<script src='js/jquery.center.js' type='text/javascript'></script>
	<script src='js/common.js' type='text/javascript'></script>
	<script src='js/popup.js' type='text/javascript'></script>
    </head>
    <body>
	<div id='backgroundPopup'></div>
	<div id='main'><!-- MAIN BAR -->
	    <div id='head-bar'><!-- HEAD BAR -->
		<a href='index.php'><img src='img/logo_header.png' class='head-logo' alt='Header logo'/></a>
	    </div><!-- /HEAD BAR -->
<?php

if($dbConfig == true) {
    $db = OpenDB();
    if($db == false) {
	echo "<div class='errorBox' id='errorBox'>Error while connecting to MySQL DB: please check configuration !</div>";
	$dbConfig = false;
    }
    $dbPopulate = false;
}

if($_POST["action"] == "checkDb") {
    /* Check DB Values and, if OK, create config.inc.php ! */
    $dbHost = $_POST["dbHost"];
    $dbName = $_POST["dbName"];
    $dbUsername = $_POST["dbUsername"];
    $dbPassword = $_POST["dbPassword"];
    
    $db = mysql_connect($dbHost,$dbUsername,$dbPassword);
    if($db == false) {
        echo "<div class='errorBox' id='errorBox'>Cannot connect to $dbHost with $dbUsername:$dbPassword !</div>";
    } else {
	if(mysql_select_db($dbName,$db)) {
	    /* OK, values are correct ! Save to config.inc.php */
	    $myConfig = "<?php\n";
	    $myConfig .= "# MySQL Database configuration\n";
	    $myConfig .= "\$CFG[\"dbHost\"] = \"$dbHost\";\n";
	    $myConfig .= "\$CFG[\"dbName\"] = \"$dbName\";\n";
	    $myConfig .= "\$CFG[\"dbUser\"] = \"$dbUsername\";\n";
	    $myConfig .= "\$CFG[\"dbPwd\"] = \"$dbPassword\";\n";
	    $myConfig .= "# XML-RPC\n";
	    $myConfig .= "\$CFG[\"xmlRpcServer\"] = \"http://www.zerozone.it/Software/Linux/SquidTL/xmlrpc.php\";\n";
	    $myConfig .= "?>\n";
	    $fp = fopen('config.inc.php', 'w');
	    if($fp) {
		fwrite($fp, $myConfig);
		fclose($fp);
		$dbConfig = true;
	    } else {
    		echo "<div class='errorBox' id='errorBox'>Cannot write configuration to config.inc.php !</div>";
    		echo "Please copy&paste following text to config.inc.php:<br><pre>".htmlentities($myConfig)."</pre><br> before proceeding !";
	    }
	} else {
	    $result = mysql_query("CREATE DATABASE IF NOT EXISTS squidtl;");
	    if($result === false) {
		echo "<div class='errorBox' id='errorBox'>Connection to DB was done but unable to create DB $dbName (".mysql_error().") ! Please create $dbName by hand and try again.</div>";
	    } else {
		$dbConfig = true;
	    }
	}
    }
} else if($_POST["action"] == "populateDb") {
    $tables = array();
    /* DB is OK, populate it ! */
    $tables[] = "DROP TABLE IF EXISTS `squidtl`.`DB_Access`;";
    $tables[] = "CREATE TABLE  `squidtl`.`DB_Access` (
  `ID` int(11) NOT NULL auto_increment,
  `Src` varchar(30) NOT NULL,
  `Domain` varchar(255) NOT NULL,
  `FullUrl` text NOT NULL,
  `Ident` varchar(255) NOT NULL,
  `realIdent` varchar(255) NOT NULL,
  `Context` varchar(16) NOT NULL,
  `AddDate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1;";
    $tables[] = "DROP TABLE IF EXISTS `squidtl`.`DB_Context`;";
    $tables[] = "CREATE TABLE  `squidtl`.`DB_Context` (
  `ID` varchar(16) NOT NULL,
  `Description` text NOT NULL,
  `ipRange` text NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Contesti';";
    $tables[] = "DROP TABLE IF EXISTS `squidtl`.`DB_Events`;";
    $tables[] = "CREATE TABLE  `squidtl`.`DB_Events` (
  `ID` int(11) NOT NULL auto_increment,
  `RulesID` int(11) default NULL,
  `Src` varchar(30) NOT NULL,
  `Ident` varchar(255) NOT NULL,
  `AddDate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1;";
    $tables[] = "DROP TABLE IF EXISTS `squidtl`.`DB_Groups`;";
    $tables[] = "CREATE TABLE  `squidtl`.`DB_Groups` (
  `ID` int(11) NOT NULL auto_increment,
  `Name` varchar(255) NOT NULL,
  `Context` varchar(16) NOT NULL,
  `Description` text NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1;";
    $tables[] = "DROP TABLE IF EXISTS `squidtl`.`DB_Rules`;";
    $tables[] = "CREATE TABLE  `squidtl`.`DB_Rules` (
  `ID` int(11) NOT NULL auto_increment,
  `Type` varchar(30) NOT NULL,
  `Value` varchar(255) NOT NULL,
  `Action` varchar(32) NOT NULL,
  `MaxHits` int(11) NOT NULL,
  `TimeSlice` int(11) NOT NULL,
  `redirectUrl` varchar(255) NOT NULL,
  `Context` varchar(16) NOT NULL,
  `Description` text NOT NULL,
  `isActive` tinyint(1) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1;";
    $tables[] = "DROP TABLE IF EXISTS `squidtl`.`DB_Sessions`;";
    $tables[] = "CREATE TABLE  `squidtl`.`DB_Sessions` (
  `ID` varchar(64) NOT NULL,
  `Username` varchar(255) NOT NULL,
  `Context` varchar(16) NOT NULL,
  `AddDate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `LastUpdate` timestamp NOT NULL default '0000-00-00 00:00:00'
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Sessioni utente';";
    $tables[] = "DROP TABLE IF EXISTS `squidtl`.`DB_Time`;";
    $tables[] = "CREATE TABLE  `squidtl`.`DB_Time` (
  `ID` int(11) NOT NULL auto_increment,
  `Name` varchar(32) NOT NULL,
  `Description` text NOT NULL,
  `fromHour` time NOT NULL,
  `toHour` time NOT NULL,
  `isNegate` tinyint(1) NOT NULL,
  `daysOfWeek` varchar(7) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 COMMENT='Periods of time for rule validity';";
    $tables[] = "INSERT INTO `squidtl`.`DB_Time` VALUES  (1,'24x7','24x7','00:00:00','23:59:00',0,'1111111'),
 (2,'WorkHours','WorkHours','08:00:00','18:00:00',0,'0111110');";
    $tables[] = "DROP TABLE IF EXISTS `squidtl`.`DB_Users`;";
    $tables[] = "CREATE TABLE  `squidtl`.`DB_Users` (
  `Username` varchar(255) NOT NULL,
  `Password` varchar(255) NOT NULL,
  `Type` tinyint(3) NOT NULL,
  `Context` varchar(16) NOT NULL,
  `IdentifiedBy` varchar(32) NOT NULL,
  `Value` varchar(255) NOT NULL,
  `Note` text NOT NULL,
  `isActive` tinyint(1) NOT NULL default '1',
  `AddDate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `LastLogin` timestamp NOT NULL default '0000-00-00 00:00:00',
  `ExpireDate` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  USING BTREE (`Username`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Utenti di SquidTL';";
    $tables[] = "INSERT INTO `squidtl`.`DB_Users` VALUES  ('admin','*4ACFE3202A5FF5CF467898FC58AAB1D615029441',5,'','NONE','','Administrator',1,'NOW()','0000-00-00 00:00:00','0000-00-00 00:00:00');";
    $tables[] = "DROP TABLE IF EXISTS `squidtl`.`RulesGroup`;";
    $tables[] = "CREATE TABLE  `squidtl`.`RulesGroup` (
  `ID` int(11) NOT NULL auto_increment,
  `RuleID` int(11) NOT NULL,
  `GroupID` int(11) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC COMMENT='Legame Regole-Gruppi';";
    $tables[] = "DROP TABLE IF EXISTS `squidtl`.`RulesTime`;";
    $tables[] = "CREATE TABLE  `squidtl`.`RulesTime` (
  `ID` int(11) NOT NULL auto_increment,
  `RuleID` int(11) NOT NULL,
  `TimeID` int(11) NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC COMMENT='Validità Regole/Periodo di temp';";
    $tables[] = "DROP TABLE IF EXISTS `squidtl`.`UserGroup`;";
    $tables[] = "CREATE TABLE  `squidtl`.`UserGroup` (
  `ID` int(11) NOT NULL auto_increment,
  `UserID` varchar(255) NOT NULL,
  `GroupID` int(11) NOT NULL,
  PRIMARY KEY  (`ID`),
  UNIQUE KEY `IdxUnique` (`UserID`,`GroupID`),
  KEY `new_index` (`UserID`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1 COMMENT='Legame Utenti-Gruppi';";
    $tables[] = "DROP TABLE IF EXISTS `squidtl`.`DB_Log`;";
    $tables[] = "CREATE TABLE `DB_Log` (
    `ID` int(11) NOT NULL auto_increment,
    `SessionID` varchar(64) default NULL,
    `Message` text NOT NULL,
    `AddDate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
    `IP` varchar(16) NOT NULL,
    PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Operational Log'";
    $tables[] = "DROP TABLE IF EXISTS `squidtl`.`DB_UsersMeta`;";
    $tables[] = "CREATE TABLE `DB_UsersMeta` (
    `Username` varchar(255) NOT NULL,
    `Type` varchar(128) NOT NULL,
    `Value` text NOT NULL,
    `AddDate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
    `ChgDate` timestamp NOT NULL default '0000-00-00 00:00:00',
    PRIMARY KEY  (`Username`,`Type`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Anagrafica utenti'";

    foreach($tables as $sqlLine) {
	$result = mysql_query($sqlLine);
	if($result === false) {
    	    echo "<div class='errorBox'>MySQL error: ".mysql_error()."</div>";
	    exit(1);
	}
    }

    // Setup ACLs for administrator...
    $allAcls = array("canLogin","canChangePwd","canViewUrls","canPurgeUrls","canViewLogs","canPurgeLogs","canViewRules","canCreateRules","canViewUsers","canCreateUsers","canViewStats");
    foreach($allAcls as $myAcl) {
	setUserACL("admin",$myAcl,true);
    }
    
    echo "<div class='messageBox'>OK, Database was initialized successfully !</div>";
    echo "Now you can <a href='index.php'>click here</a> and login as <b>admin</b> (password <b>admin</b>) into SquidTL control panel. Have fun !";
    $dbPopulate = true;
}

if($dbConfig == false) {
    echo "<form method='POST'>
    <input type='hidden' name='action' value='checkDb'>
    <div class='itemRow'>
	DB Host: <input type='text' name='dbHost' value='".$CFG["dbHost"]."'>
    </div>
    <div class='itemRow'>
	DB Name: <input type='text' name='dbName' value='".$CFG["dbName"]."'>
    </div>
    <div class='itemRow'>
	DB Username: <input type='text' name='dbUsername' value='".$CFG["dbUser"]."'>
    </div>
    <div class='itemRow'>
	DB Password: <input type='text' name='dbPassword' value=".$CFG["dbPwd"].">
    </div>
    <input type=submit value='Check DB'>
    </form>";
} else if($dbPopulate == false) {
    $result = mysql_query("SELECT * FROM DB_UsersMeta;");
    if($result === false) {
	echo "<div class='messageBox'>You need to upgrade your database !</div>";
    } else {
	/* "DB_UsersMeta" table was added in 0.1.1... */
	echo "<div class='errorBox'>Seems that you don't need to upgrade your DB: are you really sure to continue ?</div>";
   }
    echo "<h3>Please note: you will *definitively* loose all your existing rules, logs, users, contexts...</h3>"; 
    echo "<form method='POST'>
    <input type='hidden' name='action' value='populateDb'>
    When you are ready to initialize the Database, click ok 'Populate DB' below. If not, <a href='index.php'>click here</a> to continue.<br><br>
    <input type=submit value='Populate DB'>
    </form>";
}

?>
	</div>
    </body>
</html>