<?php
include "common.inc.php";

# Open DB
$db = OpenDB();

$authRequired = 1; /* This page can be accessed only by administrators */
headerCheckAcl("canViewUrls");

if($_GET["action"] == "purgeAll") {
    $result = mysql_query("DELETE FROM DB_Access;");
    if($result === false) {
        printf("Errore Mysql: %s\n",mysql_error());
        exit();
    }
    LOGWrite("Purged all domains");
    $echoMessage = getString("website-purgeall-done");
}

if($_POST["action"] == "setDomainCategory") {
    $myDomain = CleanInput($_POST["domain"]);
    $myCategory = CleanInput($_POST["category"]);
    $client = new IXR_Client($CFG["xmlRpcServer"]);
    if($client->query('squidTl.setCategory',$myDomain,$myCategory)) {
        $xml = simplexml_load_string($client->getResponse());
        if($xml->code == 200) {
    	    $echoMessage = "Saved $myDomain=$myCategory to XML-RPC repository";
	    LOGWrite("XMLRPC: saved $myDomain=$myCategory");
	} else {
	    $errorMessage = "Error saving to XML-RPC repository: ".$xml->code;
	}
    } else {
	$errorMessage = "XML-RPC Error ".$client->getErrorCode().": ".$client->getErrorMessage();
    }
}


include "common_header.php";

echo "<div id='divPopupLookup' class='Popup'><img src='img/spinner.gif'>&nbsp;Loading...</div>";

function printPages($page,$totalItems,$ipp) {
    if($totalItems > $ipp) {
	$fixedUrl = $_SERVER["SCRIPT_NAME"];
        echo "<div class='pageBar' id='pageDiv'>";
	if($page > 0) {
	    printf("<span class='pagespan'><a href='%s?P=%d'>Prev</a></span>",$fixedUrl,intval($page)-1);
	}
	if(ceil($totalItems / $ipp) < 30) {
	    for($i=0;$i<ceil($totalItems / $ipp);$i++) {
		if($i == $page) {
		    printf("<span class='pagespan_this'><a href='%s?P=%d'>%02d</a></span>",$fixedUrl,$i,$i+1);   
		} else {
		    printf("<span class='pagespan'><a href='%s?P=%d'>%02d</a></span>",$fixedUrl,$i,$i+1);    
		}
	    }
	} else {
	    for($i=0;$i<5;$i++) {
		if($i == $page) {
		    printf("<span class='pagespan_this'><a href='%s?P=%d'>%02d</a></span>",$fixedUrl,$i,$i+1);   
		} else {
		    printf("<span class='pagespan'><a href='%s?P=%d'>%02d</a></span>",$fixedUrl,$i,$i+1);    
		}
	    }
	    echo "<span class='pagespan'>...</span>";
	    if(($page >= 5) & ($page <= (ceil($totalItems / $ipp)-6))) {
		printf("<span class='pagespan_this'><a href='%s?P=%d'>%02d</a></span>",$fixedUrl,$page,$page+1);
	        if($page <= (ceil($totalItems / 10)-6)) {
		    printf("<span class='pagespan'><a href='%s?P=%d'>%02d</a></span>",$fixedUrl,$page+1,$page+2);
		}
		echo "<span class='pagespan'>...</span>";
	    }
	    for($i=ceil($totalItems / $ipp)-5;$i<ceil($totalItems / $ipp);$i++) {
		if($i == $page) {
		    printf("<span class='pagespan_this'><a href='%s?P=%d'>%02d</a></span>",$fixedUrl,$i,$i+1);   
		} else {
		    printf("<span class='pagespan'><a href='%s?P=%d'>%02d</a></span>",$fixedUrl,$i,$i+1);    
		}	
	    }
	}
	if(($page*$ipp) < $totalItems) {
	    printf("<span class='pagespan'><a href='%s?P=%d'>Next</a></span>",$fixedUrl,intval($page)+1);
	}
        echo "</div>";
    }
}

function isRuleExists($myDomain) {
    global $gbUserContext;
    $matchExists = 0;
    $result = mysql_query("SELECT * FROM DB_Rules WHERE Type='DOMAIN' AND Context LIKE '$gbUserContext';");
    if($result === false) {
        printf("Errore Mysql: %s\n",mysql_error());
        exit();
    }
    if(mysql_num_rows($result) > 0) {
	while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	    $myId= stripslashes($row["ID"]);
	    $myValue = stripslashes($row["Value"]);
	    $myAction = stripslashes($row["Action"]);
	    $myMaxHits = stripslashes($row["MaxHits"]);
	    $myTimeSlice = stripslashes($row["TimeSlice"]);
	    $myIsActive = stripslashes($row["isActive"]);
	    if (preg_match('/'.$myValue.'/', $myDomain)) {
		if($myIsActive == 1) {
		    if($myAction == "BLOCK") {
			echo "<img src='img/statusDeny.png'>";
		    } else {
			echo "<img src='img/statusAllow.png'>";
		    }
		} else {
		    echo "<img src='img/statusDisabled.png'>";
		}
		echo "<a href='editor.php?editRule=$myId'><img src='img/flagView.png'></a>";
		$matchExists+=1;
	    }
	}
    }
    if($matchExists == 0) {
	echo "<a href='editor.php?editRule=new&domain=".urlencode($myDomain)."'><img src='img/flagAdd.png'></a>";
    }
}

echo "<h2 class='title'><a href='#' onClick=\"$('#websiteHelpBox').slideToggle();\"><img src='/img/iconHelp.png'></a>&nbsp;".getString("website")."</h2>
<div class='helpBox' id='websiteHelpBox'>".getString("website-help")."</div>";

$result = mysql_query("SELECT DISTINCT Domain,DATE(AddDate) FROM DB_Access WHERE Context LIKE '$gbUserContext' ORDER BY AddDate DESC;");
if($result === false) {
    printf("Errore Mysql: %s\n",mysql_error());
    exit();
}
if(mysql_num_rows($result) > 0) {
    $totalRows = mysql_num_rows($result);

    $startOffs = intval($_GET["P"]) * 100;

    $result = mysql_query("SELECT DISTINCT Domain,DATE(AddDate) AS AddDay FROM DB_Access LIKE '$gbUserContext' ORDER BY AddDate DESC LIMIT 100 OFFSET $startOffs;");
    if($result === false) {
	printf("Errore Mysql: %s\n",mysql_error());
	exit();
    }
    $curDate = "";
    $c = 0;
    while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	$myDomain = stripslashes($row["Domain"]);
	$myAddDay = stripslashes($row["AddDay"]);
	if($curDate != $myAddDay) {
	    $curDate = $myAddDay;
	    echo "<div class='headerRow'><b>".PrintDate($myAddDay)."</b></div>";
	}
	echo "<div class='itemRow'><span>";
	echo isRuleExists($myDomain);
	echo "</span><span><a href='#' onClick=\"ajaxGetAccessDetails('DOMAIN=".urlencode($myDomain)."&DAY=".PrintDate($myAddDay)."','#more_$c'); return false;\"><img src='img/toggleExpand.png'></a></span>
	<span><a href='http://$myDomain' target='_new'>$myDomain</a></span><span id='lookupResult_$c'>&nbsp;<a href='#' onClick=\"ajaxAction('lookupDomain','DOMAIN=".urlencode($myDomain)."','#lookupResult_$c'); return false;\"><img src='img/iconLookup.png'></a></span></div>\n";
	echo "<div id='more_$c' class='detailsDiv' style='display:none; '><!-- MORE --></div>";
	$c++;
    }
    printPages(intval($_GET["P"]),$totalRows,100);
} else {
    
}

echo "<div class='toolBar'>";
if(getUserACL($gbUserName,"canPurgeUrls")) {
    echo "<div class='toolBarItem'><a href='?action=purgeAll' onClick=\"return confirm('".getString("website-purgeall-confirm")."'); return false;\"><img src='img/flagRed.png'>&nbsp;".getString("website-purgeall")."</a></div>";
}
echo "<div class='spacer'>&nbsp;</div>
</div>";

include "common_footer.php";

?>