<?php

include "common.inc.php";

# Open DB
$db = OpenDB();

if(isLogged(session_id())) {
    $gbUserName = isLogged(session_id());
    $gbUserContext = getContext($gbUserName);
} else {
    echo "You have to be authenticated to show this !";
    exit(1);
}

$ajaxAction = $_POST["action"];

function printUserType($userType) {
    switch($userType) {
	case 0: 
	    return "Disabled";
	    break;
	case 1: 
	    return "Normal";
	    break;
	case 3: 
	    return "Context admin";
	    break;
	case 5: 
	    return "Administrator";
	    break;
	default:
	    return "Unknown";
    }
}

if($ajaxAction == 'userSearch') {
    $myTerm = urldecode($_POST["term"]);
    if($myTerm) {
	$result = mysql_query("SELECT * FROM DB_Users WHERE Context LIKE '$gbUserContext' AND Username LIKE '%$myTerm%';");
	if($result === false) {
	    printf("Errore Mysql: %s\n",mysql_error());
	    exit();
	}
	if(mysql_num_rows($result) > 0) {
	    while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	        $myUsername = stripslashes($row["Username"]);
	        $myContext = stripslashes($row["Context"]);
	        $myType = stripslashes($row["Type"]);
		echo "<div class='itemRow'><a href='editor.php?editUser=".urlencode($myUsername)."'><img src='img/flagProperty.png' alt='".getString("users-edit")."'> $myUsername";
		if($myContext) {
		    echo "@$myContext";
		}
		echo "</a> (".PrintUserType($myType).")</div>";
	    }    
	} else {
	    echo getString("users-search-noresult");
	}
    }
}


if($ajaxAction == 'getAccessDetails') {
    $myDomain = urldecode($_POST["DOMAIN"]);
    $myAddDate = $_POST["DAY"];
    $result = mysql_query("SELECT AddDate,Src,Ident,realIdent,Context FROM DB_Access WHERE Domain='$myDomain' AND DAY(AddDate)='$myAddDate' ORDER BY AddDate DESC LIMIT 100;");
    if(mysql_num_rows($result) > 0) {
	echo "<ul>";
	while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
    	    $myAddDate = $row["AddDate"];
	    $mySrc = stripslashes($row["Src"]);
	    $myIdent = stripslashes($row["Ident"]);
	    $myContext = stripslashes($row["Context"]);
	    echo "<li>".PrintTime($myAddDate)." $myIdent";
	    if($myContext) {
		echo "@$myContext";
	    }
	    echo " (IP: $mySrc)</li>";
	}
	echo "</ul>";
    }
}


if($ajaxAction == 'checkValue') {
    $myValue = trim(urldecode($_POST["VALUE"]));
    if(($_POST["TYPE"] == "DOMAIN")||($_POST["TYPE"] == "IP")) {
	$regex = "([a-z0-9-.]*)\.([a-z]{2,3})"; // Host or IP     
	if(preg_match("/^$regex$/", $myValue)) {
	    echo "<img src='/img/flagGreen.png'>";
	} else {
	    echo "<img src='/img/flagRed.png'>";
	}
    }
}

if($ajaxAction == 'setDomainCategory') {
    $myValue = trim(urldecode($_POST["DOMAIN"]));
    echo "<h3 class='title'>Set category for $myValue</h3>
    <p>
	<form method='post'>
	<input type='hidden' name='action' value='setDomainCategory'>
	<input type='hidden' name='domain' value='$myValue'>";
    $client = new IXR_Client($CFG["xmlRpcServer"]);
    if($client->query('squidTl.getCategories')) {
        $xml = simplexml_load_string($client->getResponse());
        echo "<select name='category'>";
        foreach($xml->category as $cat) {
	    echo "<option value='$cat'>$cat</option>";
	}
	echo "</select>";
    } else {
	echo "<div class='errorBox'>Error receiving available categories ! Try again in few minutes...</div>";
    }
    echo "<p align='center'><input type='submit' value='".getString("send")."'>&nbsp;&nbsp;&nbsp;<input type='button' onClick=\"disablePopup('Lookup');\" value='".getString("close")."'></p>
        </form>
    </p>";
}

if($ajaxAction == 'lookupDomain') {
    $myValue = trim(urldecode($_POST["DOMAIN"]));
    $client = new IXR_Client($CFG["xmlRpcServer"]);
    if($client->query('squidTl.getCategory',$myValue)) {
        $xml = simplexml_load_string($client->getResponse());
	if($xml->category) {
	    foreach($xml->category as $cat) {
    		echo "&nbsp;$cat";
	    }
	} else {
	    echo "&nbsp;Not found";
	}
	echo " <a href='#' onClick=\"centerPopup('Lookup'); loadPopup('Lookup'); ajaxAction('setDomainCategory','DOMAIN=".urlencode($myValue)."','#divPopupLookup'); return false;\"><img src='img/flagEdit.png'></a>";
    }
}

if($ajaxAction == 'getRuleValue') {
    $myValue = trim(urldecode($_POST["DEFAULT"]));
    if($_POST["TYPE"] == "CATEGORY") {
    	$client = new IXR_Client($CFG["xmlRpcServer"]);
	if($client->query('squidTl.getCategories')) {
	    $xml = simplexml_load_string($client->getResponse());
	    echo "<select name='ruleValue'>";
	    foreach($xml->category as $cat) {
		echo "<option value='$cat'>$cat</option>";
	    }
	    echo "</select>";
	} else {
	    echo "<input type='text' name='ruleValue' value='$myValue' onchange=\"ajaxAction('checkValue','VALUE='+encodeURIComponent(this.value)+'&TYPE='+encodeURIComponent(form.ruleType.value)','#divCheckValue');\" MAXLENGTH=255><div id='divCheckValue' style='float: left;'></div>";
	}
    } else {
	echo "<input type='text' name='ruleValue' value='$myValue' onchange=\"ajaxAction('checkValue','VALUE='+encodeURIComponent(this.value)+'&TYPE='+encodeURIComponent(form.ruleType.value),'#divCheckValue');\" MAXLENGTH=255><div id='divCheckValue' style='float: left;'></div>";
    }
}

###
### TIME PERIODS
###

if($ajaxAction == 'timeManage') {
    echo "<p>";
    echo "<h3 class='title'>".getString("time-manage")."</h3><form>";
    $result = mysql_query("SELECT * FROM DB_Time;");
    if(mysql_num_rows($result) > 0) {
	while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	    $timeId = $row["ID"];
	    $timeName = stripslashes($row["Name"]);
	    $timeDescription = stripslashes($row["Description"]);
	    echo "<a href='#' onClick=\"centerPopup('Time'); loadPopup('Time'); ajaxTimeProperties('$timeId','#divPopupTime'); return false;\"><img src='img/flagTime.png'>&nbsp;$timeName</a><br>";
	}
    }
    echo "<p align='center'><input type='button' onClick=\"centerPopup('Time'); loadPopup('Time'); ajaxTimeProperties('','#divPopupTime'); return false;\" value='".getString("time-addnew")."'><input type='button' onClick=\"disablePopup('Time');\" value='".getString("close")."'></p>
        </form>
    </p>";
}

$daysArray = array("Sun","Mon","Tue","Wed","Thu","Fri","Sat");

if($ajaxAction == 'editTime') {
    $myId = $_POST["ID"];
    echo "<script type='text/javascript'>
    function checkForm(form) {
	    if(form.timeName.length < 1) {
	        alert('Devi specificare il nome utente !');
	        return false;
	    }
	    return true;
    }
    function copyToList(from,to) {
	fromList = document.getElementById(from);
	toList = document.getElementById(to);
	if (toList.options.length > 0 && toList.options[0].value == 'temp') {
	    toList.options.length = 0;
	}
	var sel = false;
	for (i=0;i<fromList.options.length;i++) {
	    var current = fromList.options[i];
	    if (current.selected) {
    		sel = true;
    		if (current.value == 'temp') {
    		    return;
    		}
		txt = current.text;
		val = current.value;
		toList.options[toList.length] = new Option(txt,val);
		fromList.options[i] = null;
		i--;
	    }
	}
    }
    function allSelect(list)   {
	List = document.getElementById(list);
        if (List.length && List.options[0].value == 'temp') return;
        for (i=0;i<List.length;i++) {
    	    List.options[i].selected = true;
	}
    }

    </script>
    <p>
	<form method='post' action='rules.php' onSubmit='allSelect(\"myRules\"); return checkForm(this);'>";
    $result = mysql_query("SELECT * FROM DB_Time WHERE ID='$myId';");
    if($result === false) {
	printf("Errore Mysql: %s\n",mysql_error());
	exit();
    }
    if(mysql_num_rows($result) > 0) {
	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	$myId = $row["ID"];
	$myName = stripslashes($row["Name"]);
	$myDescription = stripslashes($row["Description"]);
	$myFromHour = $row["fromHour"];
	$myToHour = $row["toHour"];
	$myIsNegate = $row["isNegate"];
	$myDaysOfWeek = $row["daysOfWeek"];
	echo "<h3 class='title'>".getString("time-edit")." $myName</h3>
	<input type=hidden name='action' value='time.edit'>
	<input type=hidden name='timeId' value='$myId'>";
    } else {
	echo "<h3 class='title'>".getString("time-addnew")."</h3>
	<input type=hidden name='action' value='time.addnew'>";
    }
    echo "<div class='fixedLen100'>".getString("time-name")."</div><div><input type='text' name='timeName'  value='$myName'></div>";
    echo "<div class='fixedLen100'>".getString("time-description")."</div><div><textarea name='timeDescription' style='height: 40px;'>$myDescription</textarea></div>";
    echo "<div class='fixedLen100'>".getString("time-period")."</div><div><input type='text' name='fromHour' id='fromHour' value='$myFromHour' style='width: 50px;'> - <input type='text' name='toHour' id='toHour' value='$myToHour' style='width: 50px;'> ! <input type='checkbox' name='isNegate' ".isChecked($myIsNegate)."></div>";
    // <-- Giorni della settimana
    echo "<div class='fixedLen100'>".getString("time-days")."</div><div>";
    for($i=0;$i<7;$i++) {
	if($myDaysOfWeek[$i] == '1') {
	    echo "<input type='checkbox' name='days[]' value='$i' checked>".$daysArray[$i];
	} else {
	    echo "<input type='checkbox' name='days[]' value='$i'>".$daysArray[$i];
	}
    }
    echo "<div class='spacer'>&nbsp;</div>
    <div style='float:left; width:160px; height:80px;'>
	".getString("time-allrules")."
	<select style='height:80px; width:160px;' id='allRules' multiple>";
    $result = mysql_query("SELECT * FROM DB_Rules;");
    if($result === false) {
	echo "Errore Mysql: ".mysql_error()."\n";
	exit();
    }
    if(mysql_num_rows($result) > 0) {
	while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	    $ruleId = $row["ID"];
	    $ruleType = $row["Type"];
	    $ruleValue = stripslashes($row["Value"]);
	    echo "<option value='$ruleId'>$ruleType = $ruleValue</option>";
	}
    }
    echo "</select></div>
    <div style='float: left; text-align: center; width:40px; height:80px; padding: 5px; padding-top: 20px;'>
	<a href=\"javascript:copyToList('allRules','myRules')\"><img src='img/arrowRight.png'></a><br>
	<a href=\"javascript:copyToList('myRules','allRules')\"><img src='img/arrowLeft.png'></a>
    </div>
    <div style='float:left; width:160px; height:80px;'>
	".getString("time-myrules");
    $result = mysql_query("SELECT t1.RuleID,t2.Type,t2.Value FROM RulesTime AS t1 INNER JOIN DB_Rules AS t2 ON t1.RuleID=t2.ID WHERE t1.TimeID='$myId';");
    if($result === false) {
	printf("Errore Mysql: %s\n",mysql_error());
	exit(1);
    }
    echo "<select style='height:80px; width:160px;' id='myRules' name='myRules[]' multiple>";
    if(mysql_num_rows($result) > 0) {
	while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	    $ruleId = $row["RuleID"];
	    $ruleType = $row["Type"];
	    $ruleValue = stripslashes($row["Value"]);
	   echo "<option value='$ruleId'>$ruleType = $ruleValue</option>";
	}
    }
    echo "</select></div>
    <div class='spacer'>&nbsp;</div>
    <div class='tipbox'>
        ".getString("time-tip-rules")."
    </div>";
    if($myId) {
	echo "<div class='fixedLen100'>".getString("time-deletetime")."</div><div><input type='checkbox' name='timeDelete'></div>
	<div class='tipbox'>
	    ".getString("time-tip-deletetime")."
	</div>";
    }
    // -->
    echo "<p align='center'><input type='submit' value='".getString("send")."'>&nbsp;&nbsp;&nbsp;<input type='button' onClick=\"disablePopup('Time');\" value='".getString("close")."'></p>
        </form>
    </p>";
}


###
### USERS
###

function getMysqlDate($u_DateTime) {
    list($date_str,$time_str) = explode(" ",$u_DateTime);
    list($year,$month,$day) = explode("-",$date_str);
    return $day."-".$month."-".$year;
}

if($ajaxAction == 'activateUser') {
    $myUsername = CleanInput($_POST["ID"]);
    $isActive = CleanInput($_POST["isActive"]);
    $myContainer = CleanInput($_POST["Container"]);
    $result = mysql_query("UPDATE DB_Users SET isActive=$isActive WHERE Username='$myUsername';");
    if($isActive == 1) {
        echo "<a href='#' onClick=\"ajaxActivateUser('$myUsername',0,'$myContainer'); return false;\"><img src='img/statusAllow.png'></a>";
        LOGWrite("Enabled user $myUsername");
    } else {
        echo "<a href='#' onClick=\"ajaxActivateUser('$myUsername',1,'$myContainer'); return false;\"><img src='img/statusDeny.png'></a>";
        LOGWrite("Disabled user $myUsername");
    }
}


###
### GROUPS
###


if($ajaxAction == 'editGroup') {
    $myId = $_POST["ID"];
    echo "<script type='text/javascript'>
    <!--
    function isEmpty(val) {
        if (val.match(/^s+$/) || val == \"\") {
	    return true;
	} else {
	    return false;
	} 
    }

    function checkForm(form) {
	    if(isEmpty(form.userName.value)) {
	        alert('Devi specificare il nome del gruppo !');
	        return false;
	    }
	    
	    return true;
    }
    function copyToList(from,to) {
	fromList = document.getElementById(from);
	toList = document.getElementById(to);
	if (toList.options.length > 0 && toList.options[0].value == 'temp') {
	    toList.options.length = 0;
	}
	var sel = false;
	for (i=0;i<fromList.options.length;i++) {
	    var current = fromList.options[i];
	    if (current.selected) {
    		sel = true;
    		if (current.value == 'temp') {
    		    return;
    		}
		txt = current.text;
		val = current.value;
		toList.options[toList.length] = new Option(txt,val);
		fromList.options[i] = null;
		i--;
	    }
	}
    }
    function allSelect(list)   {
	List = document.getElementById(list);
        if (List.length && List.options[0].value == 'temp') return;
        for (i=0;i<List.length;i++) {
    	    List.options[i].selected = true;
	}
    }

    //-->
    </script>
    <p>
	<form method='post' action='users.php' onSubmit='allSelect(\"myRules\"); return checkForm(this);'>";
	
    $result = mysql_query("SELECT * FROM DB_Groups WHERE ID='$myId';");
    if($result === false) {
	printf("Errore Mysql: %s\n",mysql_error());
	exit();
    }
    if(mysql_num_rows($result) > 0) {
	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	$myId = stripslashes($row["ID"]);
	$myName = stripslashes($row["Name"]);
	$myDescription = stripslashes($row["Description"]);
	echo "<h3 class='title'>".getString("groups-edit")." $myName</h3>
	<input type=hidden name='action' value='group.edit'>
	<input type=hidden name='groupId' value='$myId'>";
    } else {
	echo "<h3 class='title'>".getString("groups-addnew")."</h3>
	<input type=hidden name='action' value='group.addnew'>";
    }
    echo "<div class='fixedLen100'>".getString("groups-name")."</div><div><input type='text' name='groupName' value='$myName'></div>";
    echo "<div class='fixedLen100'>".getString("groups-description")."</div><div><textarea name='groupDescription' style='height: 60px;'>$myDescription</textarea></div>";
    if($gbUserContext == '%') {
        echo "<div class='fixedLen100'>".getString("groups-context")."</div><div>
        <select name='groupContext'>
    	    <option value=''></option>";
        $result = mysql_query("SELECT * FROM DB_Context;");
	if(mysql_num_rows($result) > 0) {
    	    while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	        $contextId = $row["ID"];
	        $contextDesc = $row["Description"];
		$contextIpRange = stripslashes($row["ipRange"]);
		echo "<option value='$contextId' ".isSelected($myContext,$contextId).">$contextId</option>";
	    }
	}
	echo "</select></div>";
    } else {
        echo "<div class='fixedLen100'>".getString("groups-context")."</div><div>
	    <input type='hidden' name='groupContext' value='$gbUserContext'>
	    <b>$gbUserContext</b>
	</div>";
    }
    // <-- Regole
    echo "<div class='spacer'>&nbsp;</div>
    <div style='float:left; width:160px; height:80px;'>
	".getString("groups-allrules")."
	<select style='height:80px; width:160px;' id='allRules' multiple>";
    $result = mysql_query("SELECT * FROM DB_Rules;");
    if($result === false) {
	echo "Errore Mysql: ".mysql_error()."\n";
	exit();
    }
    if(mysql_num_rows($result) > 0) {
	while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	    $ruleId = $row["ID"];
	    $ruleType = $row["Type"];
	    $ruleValue = stripslashes($row["Value"]);
	    echo "<option value='$ruleId'>$ruleType = $ruleValue</option>";
	}
    }
    echo "</select></div>
    <div style='float: left; text-align: center; width:40px; height:80px; padding: 5px; padding-top: 20px;'>
	<a href=\"javascript:copyToList('allRules','myRules')\"><img src='img/arrowRight.png'></a><br>
	<a href=\"javascript:copyToList('myRules','allRules')\"><img src='img/arrowLeft.png'></a>
    </div>
    <div style='float:left; width:160px; height:80px;'>
	".getString("groups-myrules");
    $result = mysql_query("SELECT t1.RuleID,t2.Type,t2.Value FROM RulesGroup AS t1 INNER JOIN DB_Rules AS t2 ON t1.RuleID=t2.ID WHERE t1.GroupID='$myId';");
    if($result === false) {
	printf("Errore Mysql: %s\n",mysql_error());
	exit(1);
    }
    echo "<select style='height:80px; width:160px;' id='myRules' name='myRules[]' multiple>";
    if(mysql_num_rows($result) > 0) {
	while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	    $ruleId = $row["RuleID"];
	    $ruleType = $row["Type"];
	    $ruleValue = stripslashes($row["Value"]);
	   echo "<option value='$ruleId'>$ruleType = $ruleValue</option>";
	}
    }
    echo "</select>
    </div><div class='spacer'>&nbsp;</div>
    <div class='tipbox'>
	".getString("groups-tip-rules")."
    </div>";
    if($myId) {
	echo "<div class='fixedLen100'>".getString("groups-deletegroup")."</div><div><input type='checkbox' name='groupDelete'></div>
	<div class='tipbox'>
	    ".getString("groups-tip-deletegroup")."
	</div>";
    }
    // -->
    echo "<p align='center'><input type='submit' value='".getString("send")."'>&nbsp;&nbsp;&nbsp;<input type='button' onClick=\"disablePopup('Group');\" value='".getString("close")."'></p>
        </form>
    </p>";
}

###
### CONTEXT
###


if($ajaxAction == 'editContext') {
    $myId = $_POST["ID"];
    echo "<script type='text/javascript'>
    <!--
    function checkForm(form) {
	    if(form.userName.length < 1) {
	        alert('Devi specificare il nome del contesto !');
	        return false;
	    }
	    return true;
    }
    //-->
    </script>
    <p>
	<form method='post' action='users.php' onSubmit='return checkForm(this);'>";
    $result = mysql_query("SELECT * FROM DB_Context WHERE ID='$myId';");
    if($result === false) {
	printf("Errore Mysql: %s\n",mysql_error());
	exit();
    }
    if(mysql_num_rows($result) > 0) {
	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	$myId = stripslashes($row["ID"]);
	$myDescription = stripslashes($row["Description"]);
	$myIpRange = stripslashes($row["ipRange"]);
	echo "<h3 class='title'>".getString("context-edit")." $myName</h3>
	<input type=hidden name='action' value='context.edit'>
	<input type=hidden name='contextId' value='$myId'>";
    } else {
	echo "<h3 class='title'>".getString("context-addnew")."</h3>
	<input type=hidden name='action' value='context.addnew'>
	<input type=text name='contextId'>";
    }
    echo "<div class='fixedLen100'>".getString("context-description")."</div><div><input type='text' name='contextDescription' value='$myDescription'></div>
    <div class='tipbox'>
        ".getString("context-tip-description")."
    </div>
    <div class='fixedLen100'>".getString("context-iprange")."</div><div><input type='text' name='contextIpRange' value='$myIpRange'></div>
    <div class='tipbox'>
        ".getString("context-tip-iprange")."
    </div>";
    if($myId) {
	echo "<div class='fixedLen100'>".getString("context-delete")."</div><div><input type='checkbox' name='contextDelete'></div>
	<div class='tipbox'>
	    ".getString("context-tip-delete")."
	</div>";
    }
    // -->
    echo "<p align='center'><input type='submit' value='".getString("send")."'>&nbsp;&nbsp;&nbsp;<input type='button' onClick=\"disablePopup('Context');\" value='".getString("close")."'></p>
        </form>
    </p>";
}

###
### RULES 
###

if($ajaxAction == 'exportRules') {
    echo "
    <p><form method='post' enctype='multipart/form-data' action='import-export.php'>
	<h3 class='title'>".getString("rules-export")."</h3>
	<input type=hidden name='action' value='rule.export'>
	<div class='fixedLen100'>Tipo file:</div><div>
	<select name='ruleType'>
	    <option value='CSV'>CSV</option>
	    <option value='PLAIN'>Plain file (1 regola per linea)</option>
	    <option value='XML'>XML</option>
	</select></div>
	<div class='tipbox'>
	    Scegli il formato di esportazione delle regole: CSV (Comma Separated Value), Plain (Testo puro e semplice) o XML (consigliato).
	</div>
	<p align='center'><input type='submit' value='".getString("send")."'>&nbsp;&nbsp;&nbsp;<input type='button' onClick=\"disablePopup('Rules');\" value='".getString("cancel")."'></p>
    </form></p>";
}

if($ajaxAction == 'importRules') {
    echo "
    <p><form method='post' enctype='multipart/form-data' action='import-export.php'>
	<h3 class='title'>".getString("rules-import")."</h3>
	<input type=hidden name='action' value='rule.import'>
	<input type='hidden' name='MAX_FILE_SIZE' value='5000000'>
	<div class='fixedLen100'>File regole:</div><div><input name='ruleFile' type='file'></div>
	<div class='fixedLen100'>Tipo file:</div><div>
	<select name='ruleType'>
	    <option value='CSV'>CSV</option>
	    <option value='XML'>XML</option>
	</select></div>
	<p align='center'><input type='submit' value='".getString("send")."'>&nbsp;&nbsp;&nbsp;<input type='button' onClick=\"disablePopup('Rules');\" value='".getString("cancel")."'></p>
    </form></p>";

}

if($ajaxAction == 'activateRule') {
    $myId = urldecode($_POST["ID"]);
    $isActive = $_POST["isActive"];
    $result = mysql_query("UPDATE DB_Rules SET isActive=$isActive WHERE ID='$myId';");
    if($isActive == 1) {
        echo "<a href='#' onClick=\"ajaxActivateRule('$myId',0,'#rule$myId'); return false;\"><img src='img/flagGreen.png'></a>";
        LOGWrite("Enabled rule $myId");
    } else {
        echo "<a href='#' onClick=\"ajaxActivateRule('$myId',1,'#rule$myId'); return false;\"><img src='img/flagRed.png'></a>";
        LOGWrite("Disabled rule $myId");
    }
}


?>