<?php

if(isset($authRequired) && ($authRequired > 0)) {
    if(!isLogged(session_id())) {
	header('Location: /');
    }
}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> 
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="it" lang="it">  
    <head>
	<title>SquidTL Administration Interface</title>
	<meta http-equiv="content-type" content="text-html; charset=UTF-8"></meta>
	<link type='text/css' rel='stylesheet' href='style/common.css'></link>
	<link type='text/css' rel='stylesheet' href='style/datepicker.css'></link>
	<script src='js/jquery.js' type='text/javascript'></script>
	<script src='js/date.js' type='text/javascript'></script>
	<script src='js/jquery.timepicker.js' type='text/javascript'></script>
	<script src='js/jquery.datepicker.js' type='text/javascript'></script>
	<script src='js/jquery.center.js' type='text/javascript'></script>
	<script src='js/common.js' type='text/javascript'></script>
	<script src='js/popup.js' type='text/javascript'></script>
    </head>
    <body>
	<div id='backgroundPopup'></div>
	<div id='main'><!-- MAIN BAR -->
	    <div id='head-bar'><!-- HEAD BAR -->
		<a href='index.php'><img src='img/logo_header.png' class='head-logo' alt='Header logo' /></a>
	    </div><!-- /HEAD BAR -->
<?php
if(isLogged(session_id())) {
    $gbUserName = isLogged(session_id());
    $gbUserContext = getContext($gbUserName);
    echo "<div class='userBar'><!-- USER BAR -->
	<div class='userItem'>".getString("login-ok")." <a href='index.php'>$gbUserName</b>@$gbUserContext</div>";
    if(getUserACL($gbUserName,"canViewUrls")) {	
	echo "<div class='userItem'><a href='urls.php'>".getString("menu-website")."</a></div>";
    }
    if(getUserACL($gbUserName,"canViewRules")) {	
	echo "<div class='userItem'><a href='rules.php'>".getString("menu-rules")."</a></div>";
    }
    if(getUserACL($gbUserName,"canViewUsers")) {	
	echo "<div class='userItem'><a href='users.php'>".getString("menu-users")."</a></div>";
    }
/*    if(getUserACL($gbUserName,"canChangePwd")) {
	echo "<div class='userItem'><a href='changepwd.php'>".getString("menu-changepwd")."</a></div>";
    } */
    if(getUserACL($gbUserName,"canViewLogs")) {
	echo "<div class='userItem'><a href='logs.php'>".getString("menu-logs")."</a></div>";
    }
/*    if(getUserACL($gbUserName,"canViewStats")) {
	echo "<div class='userItem'><a href='stats.php'>".getString("menu-stats")."</a></div>";
    } */
    echo "
	<div class='userItem'><a href='index.php?getAction=logout'>".getString("logout")."</a></div>
    </div><!-- /USER BAR -->";
}
?>

	    <div id='content-bar'><!-- CONTENT -->
<?php
if(strlen($echoMessage) > 0) {
    echo "<div class='messageBox' id='messageBox' style='display: none;'>$echoMessage</div>";
}
if(strlen($errorMessage) > 0) {
    echo "<div class='errorBox' id='errorBox' style='display: none;'>$errorMessage</div>";
}


?>